# osh
# Copyright (C) 2005 Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""Usage: blowup

Raises an exception when any input is received. Intended for use in oshapi
exception handling.
"""

import osh.oshobjects

def blowup(*args):
    return _Blowup().process_args(*args)

class _Blowup(osh.oshobjects.Op):

    # object interface

    def __init__(self):
        osh.oshobjects.Op.__init__(self, '', (0, 0))


    # OshCommand interface
    
    def doc(self):
        return __doc__

    def setup(self):
        pass


    # Receiver interface
    
    def receive(self, object):
        raise object[0]
